<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

class Pla05300DescricaoDeObservacoesDaFilial extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "descobsfilial";
    protected $parameterBagColumns = array("NRORG");

    protected $msgErro = [
    	//ERROS SAVE
    	"00001"=>"Código existente",
    	"12899"=>"O código é maior do que o valor máximo",
    	//----
    	//ERROS DELETE
    	"02292"=>"Exclusão não permitida. As informações da tabela DESCOBSFILIAL são utilizadas na tabela OBSHISTFILIAL",
    	//----
    	//ERROS FIND
    	//----
    	//ERROS GERAIS
    	"default"=>"Verifique sua conexão e tente novamente"
    ];
	
	public function find(DTO\Request\Filter $request, DTO\Response $response) {
		$this->executa('find', $request, $response);
	}

	public function save(DTO\Request $request, DTO\Response $response){
		$this->executa('save', $request, $response);
	}

	public function delete(DTO\Request $request, DTO\Response $response) {
		$this->executa('delete', $request, $response);
	}

	private function executa($funcao, $request, $response){
		try {
			parent::$funcao($request, $response);
		} catch (\Exception $e) {
			$exception = strstr($e->getMessage(), "ORA-");
			$string = strstr($exception, "-");
			$codigo = substr($string, 1, 5);

			if (array_key_exists($codigo, $this->msgErro))
				$erro = $this->msgErro[$codigo];
			else
				$erro = $this->msgErro["default"];

			$response->setError(new Error($erro, 'E'));
		}
	}
}